## qtcreator 18.0.2

=== share/qtcreator/translations/CMakeLists.txt ===
set(languages cs da de fr hr ja pl ru sl sv uk zh_CN zh_TW)
set(bad_languages hu) # Fix these before including them in languages!

find_package(Python3 COMPONENTS Interpreter)

set(json_wizards_h "")
set(custom_wizards_h "")
set(externaltools_h "")
set(snippets_h "")

if (NOT Python3_Interpreter_FOUND)
  message(WARNING "No python3 interpreter found, skipping extraction of data from XML and JSON files.\n *** Please pass -DPython3_EXECUTABLE=/path/to/python3 to cmake.")
else()
  set(json_wizards_h "${CMAKE_CURRENT_BINARY_DIR}/jsonwizards_tr.h")
  add_custom_command(OUTPUT "${json_wizards_h}"
    COMMAND "${Python3_EXECUTABLE}"
      "${CMAKE_CURRENT_SOURCE_DIR}/extract-jsonwizards.py"
      "${PROJECT_SOURCE_DIR}/share/qtcreator/templates/wizards" "${json_wizards_h}"
    COMMENT "Generate translation data from JSON wizards"
    VERBATIM)

  set(custom_wizards_h "${CMAKE_CURRENT_BINARY_DIR}/customwizards_tr.h")
  add_custom_command(OUTPUT "${custom_wizards_h}"
    COMMAND "${Python3_EXECUTABLE}"
      "${CMAKE_CURRENT_SOURCE_DIR}/extract-customwizards.py"
      "${PROJECT_SOURCE_DIR}/share/qtcreator/templates/wizards" "${custom_wizards_h}"
    COMMENT "Generate translation data from XML wizards"
    VERBATIM)

  set(externaltools_h "${CMAKE_CURRENT_BINARY_DIR}/externaltools_tr.h")
  add_custom_command(OUTPUT "${externaltools_h}"
    COMMAND "${Python3_EXECUTABLE}"
      "${CMAKE_CURRENT_SOURCE_DIR}/extract-externaltools.py"
      "${PROJECT_SOURCE_DIR}/src/share/qtcreator/externaltools" "${externaltools_h}"
    COMMENT "Generate translation data from external tools definitions"
    VERBATIM)

  set(snippets_h "${CMAKE_CURRENT_BINARY_DIR}/snippets_tr.h")
  add_custom_command(OUTPUT "${snippets_h}"
    COMMAND "${Python3_EXECUTABLE}"
      "${CMAKE_CURRENT_SOURCE_DIR}/extract-snippets.py"
      "${PROJECT_SOURCE_DIR}/share/qtcreator/snippets" "${snippets_h}"
    COMMENT "Generate translation data from snippets definitions"
    VERBATIM)
endif()

add_translation_targets(qtcreator
  TS_LANGUAGES ${languages}
  QM_LANGUAGES ${languages} en
  OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/${IDE_DATA_PATH}/translations"
  INSTALL_DESTINATION "${IDE_DATA_PATH}/translations"
  TARGETS "${__QTC_LIBRARIES}" "${__QTC_PLUGINS}"
  SOURCES "${json_wizards_h}" "${custom_wizards_h}" "${externaltools_h}" "${snippets_h}"
  OUT_VAR_TS_FILES ts_files
  OUT_VAR_QM_FILES qm_files
)

qtc_add_sbom(CreatorTranslations
  SBOM_ENTITY_TYPE QT_TRANSLATIONS
  QT_LICENSE_ID "QT_COMMERCIAL_OR_BSD3"
)

qtc_sbom_add_files(CreatorTranslations
  FILES "${qm_files}"
  SOURCE_FILES_PER_INPUT_FILE "${ts_files}"
  FILE_TYPE "QT_TRANSLATION"
  INSTALL_PATH "${IDE_DATA_PATH}/translations"
)

=== src/shared/qbs/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

if(CMAKE_VERSION VERSION_GREATER_EQUAL "3.15")
    cmake_policy(VERSION 3.15)
endif()

## Add paths to check for cmake modules:
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

include(FeatureSummary)
include(QbsBuildConfig)
include(QbsDocumentation)

file(STRINGS VERSION QBS_VERSION)
project(Qbs VERSION ${QBS_VERSION})

# Force C++ standard, do not fall back, do not use compiler extensions
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

# Set up Qt stuff:
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

find_package(QT NAMES Qt6 Qt5 COMPONENTS Core REQUIRED)

if(WITH_TESTS)
    enable_testing()
    set(QT_TEST_COMPONENT Test)
    set(IMPLICIT_DEPENDS Qt${QT_VERSION_MAJOR}::Test)
endif()

find_package(Qt${QT_VERSION_MAJOR}
    COMPONENTS Concurrent Core Gui Network Widgets Xml ${QT_TEST_COMPONENT}
    REQUIRED
    )

find_package(Qt${QT_VERSION_MAJOR} OPTIONAL_COMPONENTS Script QUIET)

if (Qt6_FOUND)
    find_package(Qt${QT_VERSION_MAJOR} COMPONENTS Core5Compat REQUIRED)
    if(NOT TARGET Qt6Core5Compat)
        if(CMAKE_VERSION VERSION_LESS 3.18)
            set_property(TARGET Qt6::Core5Compat PROPERTY IMPORTED_GLOBAL TRUE) # hack for CMake < 3.18
        endif()
        add_library(Qt6Core5Compat ALIAS Qt6::Core5Compat)
    endif()
    if (Qt6Core_VERSION VERSION_GREATER_EQUAL 6.9.0)
        find_package(Qt${QT_VERSION_MAJOR} COMPONENTS CorePrivate REQUIRED)
    endif()
else()
  if(NOT TARGET Qt6Core5Compat)
    add_library(Qt6Core5Compat INTERFACE)
  endif()
  find_package(Qt${QT_VERSION_MAJOR} OPTIONAL_COMPONENTS DocTools)
endif()

if (QBS_INSTALL_HTML_DOCS OR QBS_INSTALL_QCH_DOCS)
    find_package(Python3 COMPONENTS Interpreter)
    if (Qt6_FOUND)
        find_package(Qt${QT_VERSION_MAJOR} COMPONENTS Tools REQUIRED)
    else()
        find_package(Qt${QT_VERSION_MAJOR} COMPONENTS Help REQUIRED)
    endif()
endif()

add_definitions(-DQT_NO_QSNPRINTF -D_UCRT_NOISY_NAN)

add_subdirectory(src)
add_subdirectory(doc)
add_subdirectory(share)
if(WITH_TESTS)
    add_subdirectory(tests)
endif()

=== debian/changelog ===
qtcreator (18.0.2-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.7.3, no changes required.
  * Drop Priority: optional, no more needed since dpkg 1.22.13.
  * Drop armel from the list of architectures that need --low-mem-die-limit
    for dwz, as that architecture was discontinued.

 -- Pino Toscano <pino@debian.org>  Mon, 26 Jan 2026 21:50:55 +0100

=== debian/control ===
Source: qtcreator
Section: devel
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Adam Majer <adamm@zombino.com>,
           Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>,
           Pino Toscano <pino@debian.org>,
Build-Depends: clang (>= 1:14~),
               clangd (>= 1:17~),
               cmake (>= 3.16~),
               debhelper-compat (= 13),
               libarchive-dev,
               libclang-dev (>= 1:14~),
               libdw-dev,
               libsecret-1-dev,
               libyaml-cpp-dev (>= 0.5~),
               libzstd-dev,
               llvm-dev (>= 1:14~),
               pkgconf,
               python3:any,
               qt6-base-dev (>= 6.7.3~),
               qt6-base-private-dev (>= 6.5.4~),
               qt6-charts-dev (>= 6.5.4~),
               qt6-declarative-dev (>= 6.5.4~),
               qt6-declarative-private-dev (>= 6.5.4~),
               qt6-quick3d-dev (>= 6.5.4~),
               qt6-quick3d-private-dev (>= 6.5.4~),
               qt6-quicktimeline-dev (>= 6.5.4~),
               qt6-serialport-dev (>= 6.5.4~),
               qt6-shadertools-dev (>= 6.5.4~),
               qt6-svg-dev (>= 6.5.4~),
               qt6-tools-dev (>= 6.5.4~),
               qt6-tools-private-dev (>= 6.5.4~),
               qt6-websockets-dev (>= 6.5.4~),
               xxd,
               zlib1g-dev,
Standards-Version: 4.7.3
Homepage: https://doc.qt.io/qt-5/topics-app-development.html
Vcs-Git: https://salsa.debian.org/qt-kde-team/qt/qtcreator.git
Vcs-Browser: https://salsa.debian.org/qt-kde-team/qt/qtcreator

Package: qtcreator
Architecture: any
Depends: clangd (>= 1:17~),
         libqt6sql6-sqlite,
         qml6-module-qtqml-models,
         qml6-module-qtqml-workerscript,
         qml6-module-qtquick-controls,
         qml6-module-qtquick-layouts,
         qml6-module-qtquick,
         qtcreator-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: clang-tidy,
            gdb,
            make,
            qml-qt6,
            qt6-qmltooling-plugins,
            qt6-base-dev,
            qtcreator-doc,
            qt6-declarative-dev-tools,
            qt6-tools-dev-tools,
            qt6-translations-l10n,
            xterm | x-terminal-emulator
Suggests: clazy (>= 1.5), cmake, g++, git, meson, subversion, valgrind,
          python3-pylsp,
Description: integrated development environment (IDE) for Qt
 Qt Creator is a cross-platform integrated development environment (IDE)
 designed to make development with the Qt application framework faster
 and easier.
 .
 It includes:
  * An advanced C++ code editor
  * Integrated GUI layout and forms designer
  * Project and build management tools
  * Integrated, context-sensitive help system
  * Visual debugger
  * Rapid code navigation tools
  * Supports multiple platforms
  * Qt Quick Designer

Package: qtcreator-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: application data for Qt Creator IDE
 This package contains architecture-independent data for Qt Creator IDE.

Package: qtcreator-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: qt6-image-formats-plugins,
         ${misc:Depends},
Description: documentation for Qt Creator IDE
 Qt Creator is a cross-platform integrated development environment (IDE)
 designed to make development with the Qt application framework faster
 and easier.
 .
 This package contains documentation for Qt Creator IDE.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/dpkg/architecture.mk

# Do not build the HelloWorld plugin, as it is not needed
export QTC_BUILD_PLUGIN_HELLOWORLD=FALSE

# The upstream version of a package passed as parameter
upstream_version_of_pkg = $(shell dpkg-query -f '$${Version}' -W $(1) | sed -e 's/-[^-]*$$//')

# the dwz processing for all the libraries and plugins can take a lot of memory,
# which may be not enough on some architectures (typically 32bit), resulting in
# dwz failing with "Could not allocate memory: Cannot allocate memory" errors;
# hence, on architectures where we see this result, try to use a more memory
# friendly processing for a lower number of DIEs (dwz default is 10M)
archs_with_dwz_low_mem = armhf hurd-i386
dwz_low_mem = 3000000

%:
	dh $@ --builddirectory=builddir

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake -- \
		-DBUILD_QBS=OFF \
		-DWITH_TESTS=OFF \
		-DBUILD_TESTING=OFF \
		-DCLANGTOOLING_LINK_CLANG_DYLIB=ON \
		-DBUILD_EXECUTABLE_CMDBRIDGE=OFF \
		-DWITH_DOCS=$(if $(filter qtcreator-doc, $(shell dh_listpackages)),ON,OFF) \
		$(EXTRA_CMAKE_ARGS)

execute_after_dh_auto_build-indep:
	dh_auto_build -- docs

execute_after_dh_auto_install:
ifneq (,$(filter qtcreator-doc, $(shell dh_listpackages)))
	DESTDIR=$(CURDIR)/debian/tmp cmake --install $(CURDIR)/builddir --component qch_docs
	DESTDIR=$(CURDIR)/debian/tmp cmake --install $(CURDIR)/builddir --component html_docs
endif

	# Not needed
	rm debian/tmp/usr/bin/qtcreator.sh

	# License files of the embedded copy of KSyntaxHighlighting
	rm -rf debian/tmp/usr/share/qtcreator/generic-highlighter/syntax/licenses/

execute_after_dh_install:
	# Copied in qtcreator-doc already
	rm -rf debian/qtcreator-data/usr/share/qtcreator/doc/

override_dh_makeshlibs:
	dh_makeshlibs -Xusr/lib/$(DEB_HOST_MULTIARCH)/qtcreator/

override_dh_shlibdeps:
	echo 'libQt6DesignerComponents 6 libqt6designercomponents6 (>= $(call upstream_version_of_pkg,libqt6designercomponents6)~)' > debian/shlibs.local
	dh_shlibdeps -l$(CURDIR)/debian/qtcreator/usr/lib/$(DEB_HOST_MULTIARCH)/qtcreator
	rm debian/shlibs.local

ifeq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), $(archs_with_dwz_low_mem)))
override_dh_dwz:
	dh_dwz -- --low-mem-die-limit $(dwz_low_mem)
endif

override_dh_strip:
	dh_strip -Xusr/libexec/qtcreator/cmdbridge
